<?php
// enables widgetized sidebars
if ( function_exists('register_sidebar') )
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Sidebar Widget
// Location: the sidebar
register_sidebar(array('name'=>'Sidebar',
	'id' => 'sidebar-1',
	'before_widget' => '<div class="widget-area widget-sidebar %2$s">',
	'after_widget' => '<div class="clearleft"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div><div class="top-border"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Header Widget
// Location: header
register_sidebar(array('name'=>'Header Widgets',
	'id' => 'sidebar-3',
	'before_widget' => '<div class="widget-area widget-header %2$s">',
	'after_widget' => '<div class="clearright"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Footer Widget
// Location: at the top of the footer, above the copyright
register_sidebar(array('name'=>'Footer',
	'id' => 'sidebar-2',
	'before_widget' => '<div class="widget-area widget-footer %2$s">',
	'after_widget' => '</div>',
	'before_title' => '<h4>',
	'after_title' => '</h4>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Post thumbnail support
add_theme_support( 'post-thumbnails' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add RSS links
add_theme_support( 'automatic-feed-links' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Processing shortcode for output in feeds
add_filter('the_content_rss', 'do_shortcode');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds the post thumbnail to the RSS feed
function cwc_rss_post_thumbnail($content) {
	global $post;
	if(has_post_thumbnail($post->ID)) {
		$content = '<p>' . get_the_post_thumbnail($post->ID) .
		'</p>' . get_the_content();
	}
	return $content;
}
add_filter('the_excerpt_rss', 'cwc_rss_post_thumbnail');
add_filter('the_content_feed', 'cwc_rss_post_thumbnail');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom menu support
add_theme_support( 'menus' );
if ( function_exists( 'register_nav_menus' ) ) {
	register_nav_menus(
		array(
		  'header-menu' => 'Sliding Top Menu',
		  'category-menu' => 'Main Menu Above Content'
		)
	);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds Post Format support
// learn more: http://codex.wordpress.org/Post_Formats
// add_theme_support( 'post-formats', array( 'aside', 'gallery','link','image','quote','status','video','audio','chat' ) );

// Removes detailed login error information for security
add_filter('login_errors',create_function('$a', "return null;"));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Removes the WordPress version from your header for security
function wb_remove_version() {
	return '<!--built on the Whiteboard Framework-->';
}
add_filter('the_generator', 'wb_remove_version');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Removes Trackbacks from the comment count
add_filter('get_comments_number', 'comment_count', 0);
function comment_count( $count ) {
	if ( ! is_admin() ) {
		global $id;
		$comments_by_type = &separate_comments(get_comments('status=approve&post_id=' . $id));
		return count($comments_by_type['comment']);
	} else {
		return $count;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// This is needed for the system to create proper versions of uploaded photos and embedded videos
if ( ! isset( $content_width ) ) $content_width = 950;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// invite rss subscribers to comment
function rss_comment_footer($content) {
	if (is_feed()) {
		if (comments_open()) {
			$content .= 'Comments are open! <a href="'.get_permalink().'">Add yours!</a>';
		}
	}
	return $content;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// custom excerpt ellipses for 2.9+
function custom_excerpt_more($more) {
	return 'Read More &raquo;';
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

add_filter('excerpt_more', 'custom_excerpt_more');
// no more jumping for read more link
function no_more_jumping($post) {
	if(isset($post->ID)) { return '<a href="'.get_permalink($post->ID).'" class="read-more">'.'&nbsp; Continue Reading &raquo;'.'</a>'; }
}
add_filter('excerpt_more', 'no_more_jumping');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// category id in body and post class
function category_id_class($classes) {
	if(is_page || is_post) {
	global $post;
	foreach((get_the_category($post->ID)) as $category)
		$classes [] = 'cat-' . $category->cat_ID . '-id';
		return $classes;
}
add_filter('post_class', 'category_id_class');
add_filter('body_class', 'category_id_class'); }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// adds a class to the post if there is a thumbnail
function has_thumb_class($classes) {
	global $post;
	if( has_post_thumbnail($post->ID) ) { $classes[] = 'has_thumb'; }
		return $classes;
}
add_filter('post_class', 'has_thumb_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add_action( 'admin_init', 'theme_options_init' );
// add_action( 'admin_menu', 'theme_options_add_page' );

// Init plugin options to white list our options
// function theme_options_init(){
// 	register_setting( 'tat_options', 'tat_theme_options', 'theme_options_validate' );
// }

// Load up the menu page
// function theme_options_add_page() {
// 	add_theme_page( __( 'Theme Options', 'tat_theme' ), __( 'Theme Options', 'tat_theme' ), 'edit_theme_options', 'theme_options', 'theme_options_do_page' );
// }

// Make theme available for translation
// Translations can be filed in the /languages/ directory
load_theme_textdomain('fuji', get_template_directory() . '/languages');

$locale = get_locale();
$locale_file = get_template_directory() . "/languages/$locale.php";
if ( is_readable( $locale_file ) )
require_once( $locale_file );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// enable threaded comments
function enable_threaded_comments(){
if (!is_admin()) {
	if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
		wp_enqueue_script('comment-reply');
	}
}
add_action('get_header', 'enable_threaded_comments');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//add fancybox support
// DEF

define( 'EASY_FANCYBOX_VERSION', '1.3.4.9' );
define( 'FANCYBOX_VERSION', '1.3.4' );
define( 'MOUSEWHEEL_VERSION', '3.0.4' );
define( 'EASING_VERSION', '1.3' );
define( 'METADATA_VERSION', '2.1' );
define( 'FANCYBOX_SUBDIR', '/includes/easy-fancybox' );



require_once(dirname(__FILE__) . FANCYBOX_SUBDIR . '/easy-fancybox-settings.php');

$easy_fancybox_array = easy_fancybox_settings();

// FUNCTIONS //

function easy_fancybox() {
global $easy_fancybox_array;

echo '
<!-- Easy FancyBox ' . EASY_FANCYBOX_VERSION . ' using FancyBox ' . FANCYBOX_VERSION . ' - RavanH (http://4visions.nl/en/wordpress-plugins/easy-fancybox/) -->';

// check for any enabled sections
$do_fancybox = false;
foreach ($easy_fancybox_array['Global']['options']['Enable']['options'] as $value) {
	// anything enabled?
	if ( '1' == get_option($value['id'],$value['default']) ) {
		$do_fancybox = true;
		break;
	}
}
// and break off when none are active
if (!$do_fancybox) {
	echo '
<!-- No sections enabled under Settings > Media > FancyBox -->

';
	return;
}

// begin output FancyBox settings
echo '
<script type="text/javascript">
/* <![CDATA[ */
jQuery(document).ready(function($){
var fb_timeout = null;';

/*
 * Global settings routine
 */
$more=0;
echo '
var fb_opts = {';
foreach ($easy_fancybox_array['Global']['options'] as $globals) {
	foreach ($globals['options'] as $_key => $_value) {
		if( isset($_value['default']) && isset($_value['id'])) { $parm = ($_value['id']) ? get_option($_value['id'], $_value['default']) : $_value['default']; }
		if( isset($_value['input'])) { $parm = ('checkbox'==$_value['input'] && ''==$parm) ? '0' : $parm; }
		if( isset($_value['hide']) && !$_value['hide'] && $parm!='') {
			$quote = (is_numeric($parm) || $_value['noquotes']) ? '' : '\'';
			if ($more>0)
				echo ',';
			echo ' \''.$_key.'\' : ';
			if ('checkbox'==$_value['input'])
				echo ( '1' == $parm ) ? 'true' : 'false';
			else
				echo $quote.$parm.$quote;
			$more++;
		} else {
			$$_key = $parm;
		}
	}
}
echo ' };';

foreach ($easy_fancybox_array as $key => $value) {
	// check if not enabled or hide=true then skip
	if ( isset($value['hide']) && $value['hide'] || !get_option($easy_fancybox_array['Global']['options']['Enable']['options'][$key]['id'], $easy_fancybox_array['Global']['options']['Enable']['options'][$key]['default']) )
		continue;

	echo '
/* ' . $key . ' */';
	/*
	 * Auto-detection routines (2x)
	 */
	$autoAttribute = get_option( $value['options']['autoAttribute']['id'], $value['options']['autoAttribute']['default'] );
	// update from previous version:
	if($attributeLimit == '.not(\':empty\')')
		$attributeLimit = ':not(:empty)';
	elseif($attributeLimit == '.has(\'img\')')
		$attributeLimit = ':has(img)';
	
	if(!empty($autoAttribute)) {
		if(is_numeric($autoAttribute)) {
			echo '
$(\'a['.$value['options']['autoAttribute']['selector'].']:not(.nofancybox)'.$attributeLimit.'\')';
			if ($value['options']['autoAttribute']['href-replace'])
				echo '.attr(\'href\', function(index, attr){'.$value['options']['autoAttribute']['href-replace'].'})';
			echo '.addClass(\''.$value['options']['class']['default'].'\');';
		} else {
			// set selectors
			$file_types = array_filter( explode( ' ', str_replace( ',', ' ', $autoAttribute ) ) );
			$more=0;
			echo '
var fb_'.$key.'_select = \'';
			foreach ($file_types as $type) {
				if ($more>0)
					echo ',';
				echo 'a['.$value['options']['autoAttribute']['selector'].'".'.$type.'"]:not(.nofancybox)'.$attributeLimit.',a['.$value['options']['autoAttribute']['selector'].'".'.strtoupper($type).'"]:not(.nofancybox)'.$attributeLimit;
				$more++;
			}
			echo '\';';

			// class and rel depending on settings
			if( '1' == get_option($value['options']['autoAttributeLimit']['id'],$value['options']['autoAttributeLimit']['default']) ) {
				// add class
				echo '
var fb_'.$key.'_sections = jQuery(\''.get_option($value['options']['autoSelector']['id'],$value['options']['autoSelector']['default']).'\');
fb_'.$key.'_sections.each(function() { jQuery(this).find(fb_'.$key.'_select).addClass(\''.$value['options']['class']['default'].'\')';
				// and set rel
				switch( get_option($value['options']['autoGallery']['id'],$value['options']['autoGallery']['default']) ) {
					case '':
					default :
						echo '; });';
						break;
					case '1':
						echo '.attr(\'rel\', \'gallery-\' + fb_'.$key.'_sections.index(this)); });';
						break;
					case '2':
						echo '.attr(\'rel\', \'gallery\'); });';
				}
			} else {
				// add class
				echo '
$(fb_'.$key.'_select).addClass(\''.$value['options']['class']['default'].'\')';
				// set rel
				switch( get_option($value['options']['autoGallery']['id'],$value['options']['autoGallery']['default']) ) {
					case '':
					default :
						echo ';';
						break;
					case '1':
						echo ';
var fb_'.$key.'_sections = jQuery(\''.get_option($value['options']['autoSelector']['id'],$value['options']['autoSelector']['default']).'\');
fb_'.$key.'_sections.each(function() { jQuery(this).find(fb_'.$key.'_select).attr(\'rel\', \'gallery-\' + fb_'.$key.'_sections.index(this)); });';
						break;
					case '2':
						echo '.attr(\'rel\', \'gallery\');';
				}
			}
			
		}
	}
	
	if( isset($value['autoAttributeAlt']) ) {
	$autoAttributeAlt = get_option( $value['options']['autoAttributeAlt']['id'], $value['options']['autoAttributeAlt']['default'] ); }
	if(!empty($autoAttributeAlt) && is_numeric($autoAttributeAlt)) {
		echo '
$(\'a['.$value['options']['autoAttributeAlt']['selector'].']:not(.nofancybox)'.$attributeLimit.'\')';
		if ($value['options']['autoAttributeAlt']['href-replace'])
			echo '.attr(\'href\', function(index, attr){'.$value['options']['autoAttributeAlt']['href-replace']. '})';
		echo '.addClass(\''.$value['options']['class']['default'].'\');';
	}
	
	/*
	 * Append .fancybox() function
	 */
	$trigger='';
	if( $key == $autoClick )
		$trigger = '.filter(\':first\').trigger(\'click\')';

	echo '
$(\'';
	$tags = array_filter( explode( ',' , $value['options']['tag']['default'] ));
	$more=0;
	foreach ($tags as $_tag) {
		if ($more>0)
			echo ',';
		echo $_tag.'.'.$value['options']['class']['default'];
		$more++;
	}
	echo '\').fancybox( $.extend({}, fb_opts, {';
	$more=0;
	foreach ($value['options'] as $_key => $_values) {
		if( isset($_value['id'])) { $parm = ($_values['id']) ? get_option($_values['id'], $_values['default']) : $_values['default']; }
		if( isset($_value['input'])) { $parm = ('checkbox'==$_values['input'] && ''==$parm) ? '0' : $parm; }
		if( isset($_value['hide']) && !$_value['hide'] && $parm!='') {
			$quote = (is_numeric($parm) || $_values['noquotes']) ? '' : '\'';
			if ($more>0)
				echo ',';
			echo ' \''.$_key.'\' : ';
			if ('checkbox'==$_values['input'])
				echo ( '1' == $parm ) ? 'true' : 'false';
			else
				echo $quote.$parm.$quote;
			$more++;
		}
	}
	echo ' }) )'.$trigger.';';

}

switch( $autoClick ) {
	case '':
	default :
		break;
	case '1':
		echo '
/* Auto-click */ 
$(\'#fancybox-auto\').trigger(\'click\');';
		break;
	case '99':
		echo '
/* Auto-load */ 
$(\'a[class*="fancybox"]\').filter(\':first\').trigger(\'click\');';
		break;
}
echo '
});
/* ]]> */
</script>
<style type="text/css">.fancybox-hidden{display:none}';

if ('1' == $overlaySpotlight)
	echo '#fancybox-overlay{background-image:url("'. plugins_url(FANCYBOX_SUBDIR.'/light-mask.png', __FILE__) . '");background-position:50% -3%;background-repeat:no-repeat;-o-background-size:100%;-webkit-background-size:100%;-moz-background-size:100%;-khtml-background-size:100%;background-size:100%;position:fixed}';
if ('' != $backgroundColor)
	echo '#fancybox-outer{background-color:'.$backgroundColor.'}';
if ('' != $paddingColor)
	echo '#fancybox-content{border-color:'.$paddingColor.'}';
if ('' != $textColor)
	echo '#fancybox-content{color:'.$textColor.'}';
if ('' != $frameOpacity) {
	$frameOpacity_percent = (int)$frameOpacity*100;
	echo '#fancybox-outer{filter:alpha(opacity='.$frameOpacity_percent.');-moz-opacity:'.$frameOpacity.';opacity:'.$frameOpacity.'}';
}
echo '</style>
';

}

// FancyBox Media Settings Section on Settings > Media admin page
// function easy_fancybox_settings_section() {
// 	echo '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=ravanhagen%40gmail%2ecom&item_name=Easy%20FancyBox&item_number=&no_shipping=0&tax=0&bn=PP%2dDonationsBF&charset=UTF%2d8&lc=us" title="'.__('Donate to Easy FancyBox plugin development with PayPal - it\'s fast, free and secure!','easy-fancybox').'"><img src="https://www.paypal.com/en_US/i/btn/x-click-but7.gif" style="border:none;float:right;margin:0 0 10px 10px" alt="'.__('Donate to Easy FancyBox plugin development with PayPal - it\'s fast, free and secure!','easy-fancybox').'" width="72" height="29" /></a><p>'.__('The options in this section are provided by the plugin <strong><a href="http://4visions.nl/en/wordpress-plugins/easy-fancybox/">Easy FancyBox</a></strong> and determine the <strong>Media Lightbox</strong> overlay appearance and behaviour controlled by <strong><a href="http://fancybox.net/">FancyBox</a></strong>.','easy-fancybox').' '.__('First enable each sub-section that you need. Then save and come back to adjust its specific settings.','easy-fancybox').'</p><p>'.__('Note: Each additional sub-section and features like <em>Auto-detection</em>, <em>Elastic transitions</em> and all <em>Easing effects</em> (except Swing) will have some extra impact on client-side page speed. Enable only those sub-sections and options that you actually need on your site.','easy-fancybox').' '.__('Some setting like Transition options are unavailable for SWF video, PDF and iFrame content to ensure browser compatibility and readability.','easy-fancybox').'</p>';
// }

// FancyBox Media Settings Fields
function easy_fancybox_settings_fields($args){
switch($args['input']) {
	case 'multiple':
	case 'deep':
		foreach ($args['options'] as $options)
			easy_fancybox_settings_fields($options);
		echo $args['description'];
		break;
	case 'select':
		if( !empty($args['label_for']) )
			echo '<label for="'.$args['label_for'].'">'.$args['title'].'</label> ';
		else
			echo $args['title'];
		echo '
		<select name="'.$args['id'].'" id="'.$args['id'].'">';
		foreach ($args['options'] as $optionkey => $optionvalue) {
			$selected = (get_option($args['id'], $args['default']) == $optionkey) ? ' selected="selected"' : '';
			echo '
			<option value="'.esc_attr($optionkey).'"'.$selected.'>'.$optionvalue.'</option>';
		}
		echo '
		</select> ';
		if( empty($args['label_for']) )
			echo '<label for="'.$args['id'].'">'.$args['description'].'</label> ';
		else
			echo $args['description'];
		break;
	case 'checkbox':
		if( !empty($args['label_for']) )
			echo '<label for="'.$args['label_for'].'">'.$args['title'].'</label> ';
		else
			echo $args['title'];
		$value = esc_attr( get_option($args['id'], $args['default']) );
		if ($value == "1")
			$checked = ' checked="checked"';
		else
			$checked = '';
		if ($args['default'] == "1")
			$default = __('Checked','easy-fancybox');
		else
			$default = __('Unchecked','easy-fancybox');
		if( empty($args['label_for']) )
			echo '
		<label><input type="checkbox" name="'.$args['id'].'" id="'.$args['id'].'" value="1" '.$checked.'/> '.$args['description'].'</label><br />';
		else
			echo '
		<input type="checkbox" name="'.$args['id'].'" id="'.$args['id'].'" value="1" '.$checked.'/> '.$args['description'].'<br />';
		break;
	case 'text':
		if( !empty($args['label_for']) )
			echo '<label for="'.$args['label_for'].'">'.$args['title'].'</label> ';
		else
			echo $args['title'];
		echo '
		<input type="text" name="'.$args['id'].'" id="'.$args['id'].'" value="'.esc_attr( get_option($args['id'], $args['default']) ).'" class="'.$args['class'].'"/> ';
		if( empty($args['label_for']) )
			echo '<label for="'.$args['id'].'">'.$args['description'].'</label> ';
		else
			echo $args['description'];
		break;
	default:
		echo $args['description'];
}
}


function easy_fancybox_register_settings($args){
global $easy_fancybox_array;
foreach ($args as $key => $value) {
	// check to see if the section is enabled, else skip to next
	if ( array_key_exists($key, $easy_fancybox_array['Global']['options']['Enable']['options']) && !get_option($easy_fancybox_array['Global']['options']['Enable']['options'][$key]['id'], $easy_fancybox_array['Global']['options']['Enable']['options'][$key]['default']) )
		continue;
		
	switch($value['input']) {
		case 'deep':
			// go deeper and loop back on itself 
			easy_fancybox_register_settings($value['options']);
			break;
		case 'multiple':
			add_settings_field( 'fancybox_'.$key, $value['title'], 'easy_fancybox_settings_fields', 'media', 'fancybox_section', $value);
			foreach ($value['options'] as $_value)
				if (isset($_value['id']) && $_value['id']) register_setting( 'media', $_value['id'] );	
			break;
		default:
			if ($value['id']) register_setting( 'media', 'fancybox_'.$key );
	}
}
}

function easy_fancybox_admin_init(){
load_plugin_textdomain('easy-fancybox', false, "/includes/easy-fancybox");

add_settings_section('fancybox_section', __('FancyBox','easy-fancybox'), 'easy_fancybox_settings_section', 'media');

global $easy_fancybox_array;
easy_fancybox_register_settings($easy_fancybox_array);
}

function easy_fancybox_enqueue_scripts() {
global $easy_fancybox_array;

// check for any enabled sections plus the need for easing script
$do_fancybox = false;
$easing = false;

foreach ($easy_fancybox_array['Global']['options']['Enable']['options'] as $value) {
	// anything enabled?
	if ( '1' == get_option($value['id'],$value['default']) ) {
		$do_fancybox = true;
		break;
	}
}

// break off if there is no need for any script files
if (!$do_fancybox) 
	return;

// ENQUEUE
// register main fancybox script
wp_enqueue_script('jquery.fancybox', get_stylesheet_directory_uri().FANCYBOX_SUBDIR.'/fancybox/jquery.fancybox-'.FANCYBOX_VERSION.'.pack.js', array('jquery'), FANCYBOX_VERSION);

// easing in IMG settings?
if ( ( 'elastic' == get_option($easy_fancybox_array['IMG']['options']['transitionIn']['id'],$easy_fancybox_array['IMG']['options']['transitionIn']['default']) || 
	'elastic' == get_option($easy_fancybox_array['IMG']['options']['transitionOut']['id'],$easy_fancybox_array['IMG']['options']['transitionOut']['default']) ) 
	&& 
	( '' != get_option($easy_fancybox_array['IMG']['options']['easingIn']['id'],$easy_fancybox_array['IMG']['options']['easingIn']['default']) || 
	'' != get_option($easy_fancybox_array['IMG']['options']['easingOut']['id'],$easy_fancybox_array['IMG']['options']['easingOut']['default']) ) ) {
	// first get rid of previously registered variants of jquery.easing by other plugins or theme
	// wp_deregister_script('jquery.easing');
	// wp_deregister_script('jqueryeasing');
	// wp_deregister_script('jquery-easing');
	// wp_deregister_script('easing');
	// then register our version
	wp_enqueue_script('jquery.easing', get_stylesheet_directory_uri().FANCYBOX_SUBDIR.'/fancybox/jquery.easing-'.EASING_VERSION.'.pack.js', array('jquery'), EASING_VERSION, true);
}

// first get rid of previously registered variants of jquery.mousewheel (by other plugins)
// wp_deregister_script('jquery.mousewheel');
// wp_deregister_script('jquerymousewheel');
// wp_deregister_script('jquery-mousewheel');
// wp_deregister_script('mousewheel');
// then register our version
wp_enqueue_script('jquery.mousewheel', get_stylesheet_directory_uri().FANCYBOX_SUBDIR.'/fancybox/jquery.mousewheel-'.MOUSEWHEEL_VERSION.'.pack.js', array('jquery'), MOUSEWHEEL_VERSION, true);

}

function easy_fancybox_enqueue_styles() {
// register style
wp_enqueue_style('easy-fancybox.css', get_stylesheet_directory_uri().FANCYBOX_SUBDIR.'/easy-fancybox.css.php', false, FANCYBOX_VERSION, 'screen');
}

// Hack to fix missing wmode in (auto)embed code based on Crantea Mihaita's work-around on
// http://www.mehigh.biz/wordpress/adding-wmode-transparent-to-wordpress-3-media-embeds.html
// + own hack for dailymotion iframe embed...
if(!function_exists('add_video_wmode_opaque')) {
function add_video_wmode_opaque($html, $url, $attr) {
if (strpos($html, "<embed src=" ) !== false) {
	$html = str_replace('</param><embed', '</param><param name="wmode" value="opaque"></param><embed wmode="opaque" ', $html);
	return $html;
} elseif(strpos($html, "<iframe src=\"http://player..vimeo.com/video/" ) !== false) {
	$html = str_replace('" width', '?theme=none&wmode=opaque" width', $html);
	return $html;
} else {
	return $html;
}
}
}

// HOOKS //

add_filter('embed_oembed_html', 'add_video_wmode_opaque', 10, 3);
add_action('wp_print_styles', 'easy_fancybox_enqueue_styles', 999);
add_action('wp_enqueue_scripts', 'easy_fancybox_enqueue_scripts', 999);
add_action('wp_head', 'easy_fancybox', 999);

add_action('admin_init','easy_fancybox_admin_init');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// add widget classes 
// register_sidebar(array(
//   'before_widget' => '<div id="%1$s" class="widget %2$s">',
//    'after_widget' => '</div>',
//    'before_title' => '<h2>',
//   'after_title' => '</h2>',
//    ));

/*
Plugin Name: Better Recent Posts Widget
Plugin URI: http://pippinsplugins.com/better-recent-posts-widget
Description: Provides a better recent posts widget, including thumbnails, category, and number options
Version: 1.1.5
Author: Pippin Williamson
Author URI: http://pippinsplugins.com
*/


/**
* Recent Posts Widget Class
*/
class pippin_recent_posts extends WP_Widget {


/** constructor */
function pippin_recent_posts() {
	parent::WP_Widget(false, $name = 'Better Recent Posts');	
}

/** @see WP_Widget::widget */
function widget($args, $instance) {	
	extract( $args );
	global $posttypes;
	$title 			= apply_filters('widget_title', $instance['title']);
	$cat 			= apply_filters('widget_title', $instance['cat']);
	$number 		= apply_filters('widget_title', $instance['number']);
	$offset 		= apply_filters('widget_title', $instance['offset']);
	$thumbnail_size = apply_filters('widget_title', $instance['thumbnail_size']);
	$thumbnail 		= $instance['thumbnail'];
	$posttype 		= $instance['posttype'];
	?>
		  <?php echo $before_widget; ?>
			  <?php if ( $title )
					echo $before_title . $title . $after_title; ?>
						<ul class="no-bullets">
						<?php
							global $post;
							$tmp_post = $post;
							
							// get the category IDs and place them in an array
							if($cat) {
								$args = 'posts_per_page=' . $number . '&offset=' . $offset . '&post_type=' . $posttype . '&cat=' . $cat;
							} else {
								$args = 'posts_per_page=' . $number . '&offset=' . $offset . '&post_type=' . $posttype;
							}
							$myposts = get_posts( $args );
							foreach( $myposts as $post ) : setup_postdata($post); ?>
								<li <?php if(!empty($thumbnail_size)) { $size = $thumbnail_size + 8; } ?> >
									<?php if($thumbnail == true) { ?>
										<a href="<?php the_permalink(); ?>" style="float: left; margin: 0 5px 0 0;"><?php the_post_thumbnail(array($thumbnail_size));?></a>
									<?php } ?>
									<a href="<?php the_permalink(); ?>" class="recent-post-title"><?php the_title(); ?></a><br/>
									<span class="time"><?php echo the_time('F j, Y'); ?></span>
									<div style="clear:both"></div>
								</li>
							<?php endforeach; ?>
							<?php $post = $tmp_post; ?>
						</ul>
		  <?php echo $after_widget; ?>
	<?php
}

/** @see WP_Widget::update */
function update($new_instance, $old_instance) {		
	global $posttypes;
	$instance = $old_instance;
	$instance['title'] = strip_tags($new_instance['title']);
	$instance['cat'] = strip_tags($new_instance['cat']);
	$instance['number'] = strip_tags($new_instance['number']);
	$instance['offset'] = strip_tags($new_instance['offset']);
	$instance['thumbnail_size'] = strip_tags($new_instance['thumbnail_size']);
	$instance['thumbnail'] = $new_instance['thumbnail'];
	$instance['posttype'] = $new_instance['posttype'];
	return $instance;
}

/** @see WP_Widget::form */
function form($instance) {	

	$posttypes = get_post_types('', 'objects');

	$title = esc_attr($instance['title']);
	$cat = esc_attr($instance['cat']);
	$number = esc_attr($instance['number']);
	$offset = esc_attr($instance['offset']);
	$thumbnail_size = esc_attr($instance['thumbnail_size']);
	$thumbnail = esc_attr($instance['thumbnail']);
	$posttype	= esc_attr($instance['posttype']);
	?>
	 <p>
	  <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
	  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
	</p>
	<p>
	  <label for="<?php echo $this->get_field_id('cat'); ?>"><?php _e('Category IDs, separated by commas'); ?></label> 
	  <input class="widefat" id="<?php echo $this->get_field_id('cat'); ?>" name="<?php echo $this->get_field_name('cat'); ?>" type="text" value="<?php echo $cat; ?>" />
	</p>
	<p>
	  <label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Number to Show:'); ?></label> 
	  <input class="widefat" id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" />
	</p>
	<p>
	  <label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Offset (the number of posts to skip):'); ?></label> 
	  <input class="widefat" id="<?php echo $this->get_field_id('offset'); ?>" name="<?php echo $this->get_field_name('offset'); ?>" type="text" value="<?php echo $offset; ?>" />
	</p>
	<p>
	  <input id="<?php echo $this->get_field_id('thumbnail'); ?>" name="<?php echo $this->get_field_name('thumbnail'); ?>" type="checkbox" value="1" <?php checked( '1', $thumbnail ); ?>/>
	  <label for="<?php echo $this->get_field_id('thumbnail'); ?>"><?php _e('Display thumbnails?'); ?></label> 
	</p>
	<p>
	  <label for="<?php echo $this->get_field_id('thumbnail_size'); ?>"><?php _e('Size of the thumbnails, e.g. <em>80</em> = 80px x 80px'); ?></label> 
	  <input class="widefat" id="<?php echo $this->get_field_id('thumbnail_size'); ?>" name="<?php echo $this->get_field_name('thumbnail_size'); ?>" type="text" value="<?php echo $thumbnail_size; ?>" />
	</p>
	<p>	
		<label for="<?php echo $this->get_field_id('posttype'); ?>"><?php _e('Choose the Post Type to display'); ?></label> 
		<select name="<?php echo $this->get_field_name('posttype'); ?>" id="<?php echo $this->get_field_id('posttype'); ?>" class="widefat">
			<?php
			foreach ($posttypes as $option) {
				echo '<option value="' . $option->name . '" id="' . $option->name . '"', $posttype == $option->name ? ' selected="selected"' : '', '>', $option->name, '</option>';
			}
			?>
		</select>		
	</p>
	<?php 
}


} 

// class utopian_recent_posts
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// register Recent Posts widget
add_action('widgets_init', create_function('', 'return register_widget("pippin_recent_posts");'));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add a social media widget
include_once( get_stylesheet_directory(). '/includes/social-media-widget/social-widget.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add a twitter widget
include_once( get_stylesheet_directory(). '/includes/twitter-widget/twitter-widget.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// integrate shortcodes
include_once( get_stylesheet_directory(). '/includes/shortcodes-ultimate/shortcodes-ultimate.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add a pager
require_once( get_stylesheet_directory(). '/includes/pager/pager.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add dropdown menus for mobile screens
include_once( get_stylesheet_directory(). '/includes/dropdown-menus/dropdown-menus.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add affiliate link cloaking
include_once( get_stylesheet_directory(). '/includes/link-cloaking/affiliatelinkcloaking.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add localization
include_once( get_stylesheet_directory(). '/includes/quick-localization/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// custom tag cloud 
add_filter('widget_tag_cloud_args','set_largest_tags');
function set_largest_tags($args) {
$args = array('largest'    => 8);
return $args; }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Recent posts slider 
include_once( get_stylesheet_directory(). '/includes/recent-posts-slider/recent-posts-slider.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Grunion contact form 
include_once( get_stylesheet_directory(). '/includes/contact-form/grunion-contact-form.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Option Tree integration
include_once( get_stylesheet_directory(). '/includes/option-tree/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Create filterable portfolio 
add_action('init', 'project_custom_init');      

function project_custom_init()  
{  
// The following is all the names, in our tutorial, we use "Project"
$labels = array(
	'name' => _x('Projects', 'post type general name'),
	'singular_name' => _x('Project', 'post type singular name'),
	'add_new' => _x('Add New', 'project'),
	'add_new_item' => __('Add New Project'),
	'edit_item' => __('Edit Project'),
	'new_item' => __('New Project'),
	'view_item' => __('View Project'),
	'search_items' => __('Search Projects'),
	'not_found' =>  __('No projects found'),
	'not_found_in_trash' => __('No projects found in Trash'),
	'parent_item_colon' => '',
	'menu_name' => 'Portfolio'
);

// Some arguments and in the last line 'supports', we say to WordPress what features are supported on the Project post type
$args = array(
	'labels' => $labels,
	'public' => true,
	'publicly_queryable' => true,
	'show_ui' => true,
	'show_in_menu' => true,
	'query_var' => true,
	'rewrite' => true,
	'capability_type' => 'post',
	'has_archive' => true,
	'hierarchical' => false,
	'menu_position' => null,
	'supports' => array('title','editor','author','thumbnail','excerpt','comments')
);

// We call this function to register the custom post type
register_post_type('project',$args);

// Initialize Taxonomy Labels
$labels = array(
	'name' => _x( 'Tags', 'taxonomy general name' ),
	'singular_name' => _x( 'Tag', 'taxonomy singular name' ),
	'search_items' =>  __( 'Search Types' ),
	'all_items' => __( 'All Tags' ),
	'parent_item' => __( 'Parent Tag' ),
	'parent_item_colon' => __( 'Parent Tag:' ),
	'edit_item' => __( 'Edit Tags' ),
	'update_item' => __( 'Update Tag' ),
	'add_new_item' => __( 'Add New Tag' ),
	'new_item_name' => __( 'New Tag Name' ),
);

// Register Custom Taxonomy
register_taxonomy('tagportfolio',array('project'), array(
	'hierarchical' => true, // define whether to use a system like tags or categories
	'labels' => $labels,
	'show_ui' => true,
	'query_var' => true,
	'rewrite' => array( 'slug' => 'tag-portfolio' ),
));


}  

add_filter('post_updated_messages', 'project_updated_messages');

function project_updated_messages( $messages ) {
  global $post, $post_ID;

  $messages['project'] = array(
	0 => '', // Unused. Messages start at index 1.
	1 => sprintf( __('Project updated. <a href="%s">View project</a>'), esc_url( get_permalink($post_ID) ) ),
	2 => __('Custom field updated.'),
	3 => __('Custom field deleted.'),
	4 => __('Project updated.'),
	/* translators: %s: date and time of the revision */
	5 => isset($_GET['revision']) ? sprintf( __('Project restored to revision from %s'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	6 => sprintf( __('Project published. <a href="%s">View project</a>'), esc_url( get_permalink($post_ID) ) ),
	7 => __('Project saved.'),
	8 => sprintf( __('Project submitted. <a target="_blank" href="%s">Preview project</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	9 => sprintf( __('Project scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview project</a>'),
	  // translators: Publish box date format, see http://php.net/date
	  date_i18n( __( 'M j, Y @ G:i' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	10 => sprintf( __('Project draft updated. <a target="_blank" href="%s">Preview project</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );

  return $messages;
}

function enqueue_filterable()
{
	wp_register_script( 'filterable', get_template_directory_uri() . '/scripts/filterable-portfolio/filterable.js', array( 'jquery' ) );
	wp_enqueue_script( 'filterable' );
}
add_action('wp_enqueue_scripts', 'enqueue_filterable'); 
if ( function_exists( 'add_theme_support' ) )  
{  
add_theme_support(  'post-thumbnails' );
add_image_size( 'portfolio', 500, 325, true ); 
}  

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/* Remove Option Tree From User Profile */
global $ot_admin;remove_action( 'show_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'edit_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'personal_options_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );remove_action( 'edit_user_profile_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Custom exerpt for portfolio items
function new_excerpt_more( $more ) {
if ( is_page_template('page_portfolio-two-column.php') ) {
return '...';
} }
add_filter('excerpt_more', 'new_excerpt_more');

function custom_excerpt_length( $length ) {
if ( is_page_template('page_portfolio-two-column.php') or is_page_template('page_portfolio-one-column.php') or is_page_template('page_portfolio-three-column.php') or is_page_template('page_portfolio-four-column.php') ) {
return 40;
} }
add_filter( 'excerpt_length', 'custom_excerpt_length', 999 );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Custom search form
function fuji_search_form( $form ) {
$form = '<form role="search" method="get" id="searchform" action="' . home_url( '/' ) . '" >
<div><input type="text" value="'.__('Find..').'" name="s" id="s" />
<input type="submit" id="searchsubmit" value="" />
</div>
</form>';
return $form;
}
add_filter( 'get_search_form', 'fuji_search_form' );
////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to pages with header choice options 
$prefix = 'fuji_';
$meta_box = array(
'id' => 'header-choice',
'title' => 'Custom Header',
'page' => 'page',
'context' => 'normal',
'priority' => 'high',
'fields' => array(
	array(
		'name' => 'Choose the header for this page',
		'id' => $prefix . 'header',
		'type' => 'select',
		'options' => array('','No header','Static image','Image slider','Recent posts slider','Custom HTML')
	)
)
);

add_action('admin_menu', 'mytheme_add_box');
// Add meta box
function mytheme_add_box() {
global $meta_box;
add_meta_box($meta_box['id'], $meta_box['title'], 'mytheme_show_box', $meta_box['page'], $meta_box['context'], $meta_box['priority']);
}

// Callback function to show fields in meta box
function mytheme_show_box() {
global $meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($meta_box['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'mytheme_save_data');
// Save data from meta box
function mytheme_save_data($post_id) {
global $meta_box;
// verify nonce
if (!wp_verify_nonce($_POST['mytheme_meta_box_nonce'], basename(__FILE__))) {
	return $post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($meta_box['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



?>
